#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include "DIO.h"

void    READ_CMD(char *);
short   ASCII_TO_HEX(char);
void    TEST_CMD(HWND, int, int, int, int);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

short   nDMA=-1, nIRQ=-1;
WORD    wBase=0x300,wOpen=0;
int     iLine;

/* -------------------------------------------------------------------- */

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
     {
     static char szAppName[] = "TestDIO";
     HWND        hwnd ;
     MSG         msg ;
     WNDCLASSEX  wndclass ;

     wndclass.cbSize        = sizeof(wndclass);
     wndclass.style         = CS_HREDRAW|CS_VREDRAW;
     wndclass.lpfnWndProc   = WndProc;
     wndclass.cbClsExtra    = 0;
     wndclass.cbWndExtra    = 0;
     wndclass.hInstance     = hInstance;
     wndclass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
     wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
     wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
     wndclass.lpszMenuName  = NULL;
     wndclass.lpszClassName = szAppName;
     wndclass.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);

     RegisterClassEx(&wndclass) ;
     hwnd=CreateWindow(szAppName,"TEST P16R16DIO",
                          WS_OVERLAPPEDWINDOW,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          NULL, NULL, hInstance, NULL) ;
     ShowWindow(hwnd,iCmdShow);
     UpdateWindow(hwnd);

     while (GetMessage(&msg, NULL, 0, 0))
          {
          TranslateMessage(&msg);
          DispatchMessage(&msg);
          }
     return msg.wParam;
     }

/* -------------------------------------------------------------------- */

LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
static int  cxChar, cyChar, cxClient, cyClient, cxBuffer, cyBuffer,
            xCaret, yCaret;
static char cBuf[80];
HDC         hdc;
TEXTMETRIC  tm;
PAINTSTRUCT ps;
int         i;

switch (iMsg)
  {
  case WM_CREATE :                     // window initial
       hdc=GetDC(hwnd);
       SelectObject(hdc,GetStockObject(SYSTEM_FIXED_FONT));
       GetTextMetrics(hdc, &tm);
       cxChar=tm.tmAveCharWidth;
       cyChar=tm.tmHeight;
       ReleaseDC(hwnd, hdc);
       return 0;
  case WM_SIZE :
       cxClient=LOWORD(lParam);         // window size in pixels
       cyClient=HIWORD(lParam);
       cxBuffer=max(1,cxClient/cxChar); // window size in characters
       cyBuffer=max(1,cyClient/cyChar);
       return 0;
  case WM_SETFOCUS :
       CreateCaret(hwnd, NULL, cxChar, cyChar);
       SetCaretPos(xCaret * cxChar, yCaret * cyChar);
       ShowCaret(hwnd);
       return 0;
  case WM_KILLFOCUS :
       HideCaret(hwnd);
       DestroyCaret();
       return 0;
  case WM_CHAR :                        // user press KEYBOARD
       for (i = 0 ; i < (int) LOWORD(lParam) ; i++)
       {
       switch (wParam)
         {
         case '\b' :                    // backspace pressed
           if (xCaret > 0)
           {
           xCaret-- ;
           cBuf[xCaret]=' ';
           HideCaret(hwnd);
           hdc=GetDC(hwnd);
           SelectObject(hdc,GetStockObject(SYSTEM_FIXED_FONT));
           TextOut(hdc, xCaret * cxChar, yCaret * cyChar,cBuf+xCaret,1);
           ShowCaret(hwnd);
           ReleaseDC(hwnd, hdc);
           }
           break ;
         case '\r' :                    // carriage return  pressed
           cBuf[xCaret]=0;
           if (xCaret!=0) {xCaret=0; yCaret++;}
           READ_CMD(cBuf);
           TEST_CMD(hwnd,xCaret, cxChar, yCaret,cyChar);
           xCaret=0; yCaret+=iLine;
           if (yCaret >= cyBuffer) InvalidateRect(hwnd, NULL, TRUE);
           break ;
         case '\x1B' :                  // escape pressed
           InvalidateRect (hwnd, NULL, TRUE) ;
           xCaret=yCaret=0;
           break ;
         default :                      // other KEY pressed
           cBuf[xCaret]=(char) wParam;
           HideCaret(hwnd);
           hdc=GetDC (hwnd);
           SelectObject(hdc,GetStockObject(SYSTEM_FIXED_FONT));
           TextOut(hdc,xCaret*cxChar,yCaret*cyChar,cBuf+xCaret,1);
           ShowCaret(hwnd);
           ReleaseDC(hwnd, hdc);
           xCaret++;
           break ;
         }
       }
       SetCaretPos(xCaret*cxChar, yCaret*cyChar);
       return 0;
  case WM_PAINT :                       // clr and show HELP
       InvalidateRect(hwnd, NULL, TRUE);
       hdc=BeginPaint(hwnd, &ps);
       SelectObject(hdc,GetStockObject(SYSTEM_FIXED_FONT));

       sprintf(cBuf,"NOW --> Base=%x, DMA=%d, IRQ=%d",wBase,nDMA,nIRQ);
       TextOut(hdc,0,0,cBuf,strlen(cBuf));
       xCaret = 0 ; yCaret=1;
       SetCaretPos(0,yCaret*cyChar);

       EndPaint(hwnd, &ps);
       return 0;
  case WM_DESTROY :
       NAPWNT_CLOSE();
       PostQuitMessage(0);
       return 0 ;
  }
return DefWindowProc(hwnd, iMsg, wParam, lParam);
}

/* -------------------------------------------------------------------- */
/* [0][1][2]=base_address, [4]=DMA, [6][7]=IRQ                          */
void READ_CMD(char szCmd[])
{
short nT1,nT2,nT3;

if (szCmd[0]==0) return;        // only press [Enter]

nT1=ASCII_TO_HEX(szCmd[0]);     // HEX format
nT2=ASCII_TO_HEX(szCmd[1]);
nT3=ASCII_TO_HEX(szCmd[2]);
wBase=nT1*256+nT2*16+nT3;

nDMA=ASCII_TO_HEX(szCmd[4]);    // DECIMAL format
if (nDMA==0) nDMA=-1;           // no DMA is used

nT1=ASCII_TO_HEX(szCmd[6]);     // DECIMAL format
nT2=ASCII_TO_HEX(szCmd[7]);
nIRQ=nT1*10+nT2;
if (nIRQ==0) nIRQ=-1;           // no IRQ is used
}

short ASCII_TO_HEX(char cChar)
{
if (cChar<='9') return(cChar-'0');
else if (cChar<='F') return(cChar-'A'+10);
else return(cChar-'a'+10);
}

/* -------------------------------------------------------------------- */

void TEST_CMD(HWND hwnd, int x, int dx, int y, int dy)
{
char cBuf[80],cShow[80];
HDC hdc;
WORD wRetVal,wChannel,wConfig,wType,wBuf[10],wCount,i,j,wData,wVal;
short nRetVal;
float fRetVal,fVal,fBuf[10];

if (wOpen==0)           /* need to init once */
        {
        NAPWNT_INIT(wBase);
        wOpen=1;
        }

iLine=0;
hdc=GetDC(hwnd);
HideCaret(hwnd);
SelectObject(hdc,GetStockObject(SYSTEM_FIXED_FONT));

sprintf(cShow,"----------------------------------------------------------");
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;
sprintf(cShow,"Now Setting Is --> Base=%x, DMA=%d, IRQ=%d",wBase,nDMA,nIRQ);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;


DIO_OutputByte(0x7ff4,0x55);  
wRetVal=DIO_InputByte(0x7ff4); 
sprintf(cShow,"0. 0x55 --> read back=%x",wRetVal);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;


DIO_OutputByte(0x7ff4,0xAA);  
wRetVal=DIO_InputByte(0x7ff4); 
sprintf(cShow,"0. 0xAA --> read back=%x",wRetVal);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

DIO_OutputByte(0x7f7c,0x00);  
wRetVal=DIO_InputByte(0x7f7c); 
sprintf(cShow,"0. 0x00 --> read back=%x",wRetVal);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;


DIO_OutputByte(0x7f7c,0xff);  
wRetVal=DIO_InputByte(0x7f7c); 
sprintf(cShow,"0. 0xff --> read back=%x",wRetVal);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

goto ret_label;


/* this demo is validate for P16R16 */

for (i=0; i<3; i++)          /* relays ON-OFF 5 times */
{
DIO_OutputByte(0x300,0x00);  /* R0-R7  OFF */
DIO_OutputByte(0x301,0x00);  /* R8-R15 OFF */
Sleep(500);
DIO_OutputByte(0x300,0xff);  /* R0-R7  ON  */
DIO_OutputByte(0x301,0xff);  /* R8-R15 ON  */
Sleep(500);
}

DIO_OutputByte(0x300,0x55);  /* R0-R7  OFF */
Sleep(500);
wRetVal=DIO_InputByte(0x300); 
sprintf(cShow,"1. R0-R7=0x55 --> read back=%x",wRetVal);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

DIO_OutputByte(0x300,0xAA);  /* R0-R7  OFF */
Sleep(500);
wRetVal=DIO_InputByte(0x300); 
sprintf(cShow,"2. R0-R7=0xAA --> read back=%x",wRetVal);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

DIO_OutputByte(0x301,0x55);  /* R0-R7  OFF */
Sleep(500);
wRetVal=DIO_InputByte(0x301); 
sprintf(cShow,"3. R8-R15=0x55 --> read back=%x",wRetVal);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

DIO_OutputByte(0x301,0xAA);  /* R0-R7  OFF */
Sleep(500);
wRetVal=DIO_InputByte(0x301); 
sprintf(cShow,"4. R8-R15=0xAA --> read back=%x",wRetVal);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

ret_label:
ShowCaret(hwnd);
ReleaseDC (hwnd,hdc);
}
